unit o_fb2;
  // Open file FB2
interface

uses
  SysUtils, Classes, StdCtrls, CheckLst, Dialogs,
  xmldom, XMLIntf, msxmldom, EncdDecd, XMLDoc, dm, gv;

type
  Tmfb2 = class(TDataModule)
    XMLDocument1: TXMLDocument;
  private
    { Private declarations }
  public
    { Public declarations }
  end;

  act = record
    st : string;
    li : string;
    a  : integer;
  end;

var
  mfb2: Tmfb2;
 desc  : IXMLNode;  // Description
 body  : IXMLNode;
 notes : IXMLNode;

  procedure openXML;
  procedure OpenFB2asXML;
  function MyDir(S:string): boolean;

  procedure Common(Node: IXMLNode; LB : TCheckListBox);
  procedure Common2(Node: IXMLNode; LB : TListBox);

implementation


{$R *.dfm}


var
 fb2Level : integer;

function ScanStr( S:string):string;
var
 beginTag  : boolean;
 ss  : string;
 i,n   : integer;

 tag  : string;
 AddValue : boolean;
 oldc : char;
begin
 result := '';  AddValue := true;   beginTag := false;    oldC := ' ';
for i := 1 to length(S) do
  begin
        case S[i] of
        '<' : beginTag := true;
        '>' : begin

               ss := '';
               beginTag := false;
               if Tag = '' then continue;
               n := 1;
                 repeat //  
                  Ss := Ss + Tag[n];
                  inc(n);
                 until (n > length(Tag)) or (Tag[n] in [' ','>']);

             ss := LowerCase(Ss);
               if ss = 'emphasis'
                 then result := result + '<i>'
               else
               if ss = '/emphasis'
                 then result := result + '</i>'
               else
               if ss = 'strong'
                 then result := result + '<b>'
               else
               if ss = '/strong'
                 then result := result + '</b>'
               else
               if ss = 'a'
                 then
                 begin
                  result := result + '~';
                  AddValue := false;
                 end
               else
               if ss = '/a'
                 then AddValue := true;

               Tag := '';

               end;
       else  begin
               if beginTag then
                begin
                 Tag := Tag + S[i];
                 continue;
                end;
               if S[i] < ' ' then S[i] := ' ';

               if AddValue and  ((oldc<>' ') or (S[i]<>' '))
                then result := result + S[i];
              end;
        end; // case
     oldc := S[i];
  end;
  result := trim(result);
end;

function LoadP(Node: IXMLNode):string;
var
 n : integer;
begin
 result := Node.XML;

 n := pos('>',result);
 if n > 0 then
  begin  //   xml
   delete( result, 1,n);
   delete( result, length(result)-3,4);
  end;
 result := ScanStr(result);
end;

procedure _annotation(ChNodes: IXMLNodeList);
var
 Node: IXMLNode;
begin              // 
 Node := ChNodes.First;
 while Node <> nil do
  begin
   Common2(Node, cBook.MAnnotation);
   Node := Node.NextSibling;
  end;
end;

function GetXmlns(Node: IXMLNode):string;
begin
 if Node.HasAttribute('xmlns:xlink')
  then result := Node.GetAttribute('xlink:href')
  else result := Node.GetAttribute('l:href');
 delete(result,1,1); // ,      #
end;

procedure Add_Author(ChNodes: IXMLNodeList; LBox : TListBox);
var
 Node: IXMLNode;
 LPerson : TPerson;
 n : integer;
begin              //  
 Node := ChNodes.First;
   LPerson := TPerson.Create;
   n := LBox.Items.AddObject('',LPerson);
 while Node <> nil do
  begin
    if Node.NodeName = 'first-name'
      then  LPerson.fName := Node.Text
    else
    if Node.NodeName = 'last-name'
      then  LPerson.lName := Node.Text
    else
    if Node.NodeName = 'middle-name'
      then  LPerson.mName := Node.Text
    else
    if Node.NodeName = 'home-page'
      then  LPerson.home := Node.Text
    else
    if Node.NodeName = 'email'
      then  LPerson.email := Node.Text;


    Node := Node.NextSibling;
  end;
 LBox.Items[n] := LPerson.fName + ' ' + LPerson.lName;
end;

function SetGaner(S:string):string;
var
 i : integer;
begin
 for i := 0 to maxg do
  if gg[i][1] = S then
    begin
     result := gg[i][2];
     exit;
    end;
 result := s;
end;

procedure LoadSequence(Nodes: IXMLNode);
var
 Sequ : TSequ;
begin
 Sequ := TSequ.Create;
 Sequ.series := Nodes.GetAttribute('name');
 Sequ.number := Nodes.GetAttribute('number');
 cBook.SequListBox.Items.AddObject(Sequ.series+'  '+ Sequ.number , Sequ);
end;

function GetSrc_Lang(s:string):integer;
var
 i : integer;
begin
 for i := 1 to maxL do
  if Lg[i][1] = s
   then
   begin
    result := i;
    exit;
   end;
 result := 0;
end;

procedure document_info(ChNodes: IXMLNodeList);
var
 Node: IXMLNode;
begin           //
 Node := ChNodes.First;
 with cBook do
 while Node <> nil do
  begin
    if Node.NodeName = 'id'
      then Eid.Text := Node.Text
    else
    if (Node.NodeName = 'version') and not NewPr
      then EVersion.Text := Node.Text
    else
    if Node.NodeName = 'src-url'
      then EUrl.Text := Node.Text
        else
    if Node.NodeName = 'author'
      then Add_Author(Node.ChildNodes, Authors_FB2)
        else
    if Node.NodeName = 'date'
      then
       begin
       EDate.Text := Node.Text;
//       ShowMessage(Ebook.Edate);
       end;
        // 
    Node := Node.NextSibling;
  end;
end;

procedure publish_info(ChNodes: IXMLNodeList);
var
 Node: IXMLNode;
begin           //
 Node := ChNodes.First;
 with cBook do
 while Node <> nil do
  begin
    if Node.NodeName = 'book-name'
      then Bookname.Text := Node.Text
    else
    if Node.NodeName = 'publisher'
      then Epublisher.Text := Node.Text
    else
    if Node.NodeName = 'city'
      then Ecity.Text := Node.Text
    else
    if Node.NodeName = 'year'
      then Eyear.Text := Node.Text
    else
    if Node.NodeName = 'isbn'
      then EIsbn.Text := Node.Text;



    Node := Node.NextSibling;
  end;
end;

procedure title_info(ChNodes: IXMLNodeList);
var
 Node: IXMLNode;
begin           //
 Node := ChNodes.First;
 with cBook do
 while Node <> nil do
  begin
    if Node.NodeName = 'book-title'
      then bookTitle.Text := Node.Text
    else
    if Node.NodeName = 'annotation'
      then _annotation(Node.ChildNodes)
    else
    if Node.NodeName = 'author'
      then Add_Author(Node.ChildNodes, P_ListBox)
    else
    if Node.NodeName = 'translator'
      then Add_Author(Node.ChildNodes, T_ListBox)
    else
    if Node.NodeName = 'genre'
      then Genres_Box.Items.Add(SetGaner(Node.Text))
    else
    if Node.NodeName = 'sequence'
      then LoadSequence(Node)

    else
    if Node.NodeName = 'lang'
      then
       begin
        if Node.text = 'ru'
          then P_Lang.ItemIndex :=  0
          else P_Lang.ItemIndex :=  1;
       end
    else
    if Node.NodeName = 'src-lang'
      then
        S_Lang.ItemIndex :=  GetSrc_Lang(Node.text);

    Node := Node.NextSibling;
  end;
end;

function LoadHead(ChNodes: IXMLNodeList):boolean;
var
 Node: IXMLNode;
begin
 Node := ChNodes.First;
 result := true;
 while Node <> nil do
  begin
    if Node.NodeName = 'title-info'
      then title_info(Node.ChildNodes)
    else
    if Node.NodeName = 'document-info'
      then document_info(Node.ChildNodes)
    else
    if Node.NodeName = 'publish-info'
      then publish_info(Node.ChildNodes)
    else
    if Node.NodeName = 'custom-info'
      then
       begin
        result := not (Node.GetAttribute('info-type') = 'w_cat');
       end;

    Node := Node.NextSibling;
  end;
end;

procedure NewAdd(pref, S: string; LB : TCheckListBox);
var
 y : integer;
 b : boolean;
begin
 b := false;
 if not NewPr then
 begin
 b := (length(S) > 2) and (S[1]= '[') and (S[2]= '~');
 if b            //   pos(']',S)
  then delete(S,1, 4);
 end;
// S := trim(S);
 y := LB.Items.Add(pref + S);
 if S = ''
  then
   LB.Checked[y] := true
  else
   LB.Checked[y] := not NewPr and not b;
end;

procedure LoadStanza(ChNodes: IXMLNodeList; LB : TCheckListBox);
var
 Node: IXMLNode;
 S : string;
begin
 Node := ChNodes.First;

 while Node <> nil do
  begin  // 
    if lowercase(Node.NodeName) = 'v'
     then
        begin
         S := LoadP(Node);
         NewAdd('  p| ', S, LB);
        end;

     Node := Node.NextSibling;
  end;
end;

function GetStrAtributes(Node: IXMLNode):string;
var
 index : integer;
 AttributeName,
 AttributeValue : string;
begin
  result := '';

  for Index := 0 to Node.AttributeNodes.Count - 1 do
    begin
      AttributeName := Node.AttributeNodes[Index].NodeName;
      AttributeValue := Node.Attributes[AttributeName];
      result := result + ' '+AttributeName + '="'+ AttributeValue+'"';
    end;
end;

procedure LoadTr(ChNodes: IXMLNodeList; LB : TCheckListBox);
var
 Node: IXMLNode;
begin
 Node := ChNodes.First;
 while Node <> nil do
  begin  // 
    if ( Node.NodeName = 'td') or ( Node.NodeName = 'th')
     then
     begin
      LB.Items.Add('  t| <'+Node.NodeName+ GetStrAtributes(Node) +'>' );
  //???    NewAdd('  p| ', Node, LB); // ..   ...
      LB.Items.Add('  t| </'+Node.NodeName+'>' );
     end;

  Node := Node.NextSibling;
  end;
end;

procedure LoadTable(ChNodes: IXMLNodeList; LB : TCheckListBox);
var
 Node: IXMLNode;
begin
 LB.Items.Add('  t| <table>');
 Node := ChNodes.First;
 while Node <> nil do
  begin  // 
    if Node.NodeName = 'tr'
     then
     begin
      LB.Items.Add('  t| <tr' + GetStrAtributes(Node) +'>' );
      LoadTr(Node.ChildNodes, LB);
      LB.Items.Add('  t| </tr>' );
     end;

     Node := Node.NextSibling;
  end;
 LB.Items.Add('  t| </table>');
end;


procedure LoadPoem(ChNodes: IXMLNodeList; LB : TCheckListBox);
var
 Node: IXMLNode;
// S : string;
begin
 Node := ChNodes.First;

 while Node <> nil do
  begin  // 
    if lowercase(Node.NodeName) = 'stanza'
     then
       LoadStanza(Node.ChildNodes, LB)
    else  //??
    if lowercase(Node.NodeName) = 'text-author'
     then
       NewAdd('  A| ', Node.Text, LB);


     Node := Node.NextSibling;
  end;
end;


procedure LoadEpigraph(ChNodes: IXMLNodeList; LB : TCheckListBox);
var
 Node: IXMLNode;
 S : string;
begin
 Node := ChNodes.First;

 while Node <> nil do
  begin  // 
    if lowercase(Node.NodeName) = 'p'
     then
        begin
         S := LoadP(Node);
         NewAdd('  E| ', S, LB);
        end
    else
    if lowercase(Node.NodeName) = 'text-author'
     then
         NewAdd('  A| ', LoadP(Node), LB);

     Node := Node.NextSibling;
  end;
end;

procedure Common(Node: IXMLNode; LB : TCheckListBox);
var
 S : string;
begin
    if lowercase(Node.NodeName) = 'p'
      then
       begin
        S := LoadP(Node);
        NewAdd('  N| ', S, LB);
       end
     else
    if lowercase(Node.NodeName) = 'empty-line'
      then
       begin
        NewAdd('  N| ', '', LB);
       end
     else
    if Node.NodeName = 'epigraph'   //    lowercase(
     then LoadEpigraph( Node.ChildNodes, LB)
     else
    if Node.NodeName = 'poem'     //    lowercase(
     then LoadPoem( Node.ChildNodes, LB)
     else
    if Node.NodeName = 'subtitle'   //    lowercase(
     then
         NewAdd('  S| ', LoadP(Node), LB)
     else
    if Node.NodeName = 'table'     //    lowercase(
     then LoadTable( Node.ChildNodes, LB);

end;

procedure Common2(Node: IXMLNode; LB : TListBox);
var
 S : string;
begin
    if lowercase(Node.NodeName) = 'p'
      then
       begin
        S := LoadP(Node);
         LB.Items.Add(S);

       end
     else
    if lowercase(Node.NodeName) = 'empty-line'
      then
       begin
        LB.Items.Add('');
       end
     else
     {
    if Node.NodeName = 'epigraph'   //    lowercase(
     then LoadEpigraph( Node.ChildNodes, LB)
     else
    if Node.NodeName = 'poem'     //    lowercase(
     then LoadPoem( Node.ChildNodes, LB)
     else
     }
    if Node.NodeName = 'subtitle'   //    lowercase(
     then
        LB.Items.Add(LoadP(Node));

end;

procedure LoadTitle(ss:string; ChNodes: IXMLNodeList; LB : TCheckListBox);
var
 Node: IXMLNode;
 S : string;
begin
 Node := ChNodes.First;

 while Node <> nil do
  begin  // 

    if lowercase(Node.NodeName) = 'p'                 // + sss
     then
        begin
         S := LoadP(Node);


        if ss = ' H'
         then ss := ' H' +IntToStr(fb2Level);

         NewAdd(ss +'| ', S, LB);
        end;

    Node := Node.NextSibling;
  end;
end;

function MyDir(S:string): boolean;
begin
  result := false;
  if not DirectoryExists(S) then
    if not CreateDir(S) then
    else
     begin
      result := true;
      Exception.Create('Cannot create '+S);
     end;
end;

   {
procedure ExtractImage(S, ImageName:string);
var
 i : integer;
  MSa : TMemoryStream;
  MSb : TMemoryStream;
begin
  MSa := TMemoryStream.Create;
  MSb := TMemoryStream.Create;
 for i := 1 to length(S) do
  if S[i] > ' ' then
       MSa.Write(S[i],1);  //   
 MSa.Position := 0;
 DecodeStream(MSa, MSb);
 MSb.Position := 0;
// MyDir(Path+'temp'); // ***************
// MyDir(Image_Path); // ***************
 cBook.List_Images.Items.Add(ImageName);
 MSb.SaveToFile(Image_Path+'\'+ImageName);
 MSa.Free;     MSb.Free;
end;
  }
  {
procedure GetBinary(Node: IXMLNode);
var
 FName : string;
// FType : string;
begin
 FName := Node.GetAttribute('id');
// FType := Node.GetAttribute('content-type');
 ExtractImage(Node.Text, FName);
end;
   }
procedure LoadCite( ChNodes: IXMLNodeList);
var
 Node: IXMLNode;
 S : string;
begin
 Node := ChNodes.First;
 with cBook do
 while Node <> nil do
  begin  // 

    if lowercase(Node.NodeName) = 'p'
     then
        begin
         S := LoadP(Node);
         LBcon.Items.Add('  C| '+S);
        end
     else
    if lowercase(Node.NodeName) = 'text-author'
     then
        begin
         S := LoadP(Node);
         LBcon.Items.Add('  A| '+S);
        end;
    Node := Node.NextSibling;
  end;
end;

procedure LoadSection(ChNodes: IXMLNodeList; LB : TCheckListBox);
var
 Node: IXMLNode;
begin
 Node := ChNodes.First;
 inc(fb2Level);
 if lowercase(Node.NodeName) = 'title'
     then
     begin
      LoadTitle(' H', Node.ChildNodes, LB);
      Node := Node.NextSibling;
     end
     else
      LB.Items.Add(' H' +IntToStr(fb2Level) +'| ');

 while Node <> nil do
  begin
    if lowercase(Node.NodeName) = 'section'
     then LoadSection( Node.ChildNodes, LB)
     else
    if Node.NodeName = 'cite'
     then LoadCite( Node.ChildNodes)
    else
     Common(Node, LB);

    Node := Node.NextSibling;
  end;
 dec(fb2Level);
end;


procedure LoadSecNote(ChNodes: IXMLNodeList; b : boolean);
var
 Node: IXMLNode;
 first : boolean;
 y : integer;
begin
 Node := ChNodes.First;  first := true;
 while Node <> nil do
  begin
  //  if lowercase(Node.NodeName) = 'section'
    // then LoadSecNote( Node.ChildNodes);
    if lowercase(Node.NodeName) = 'p'  //
        then
         begin
          if first then
            begin
             if b then End_NotesList.Items.Add(' H1| '+  LoadP(Node))  //
                  else End_NotesList.Items.Add('  Z| '+  LoadP(Node));
             first := false;
            end
            else
             begin
              Y:= End_NotesList.Items.Add('  N| '+  LoadP(Node));  //
              End_NotesList.Checked[y] := true;
             end;

         end;

    Node := Node.NextSibling;
  end;
end;


procedure LoadNotes(root: IXMLNode);
var
 Node: IXMLNode;
 at  : string;
begin
 if (root = nil) or (End_NotesList = nil) then exit;

 Node := root.ChildNodes.First;

 while Node <> nil do
  begin
    if lowercase(Node.NodeName) = 'section'
     then
     begin
      at := Node.GetAttribute('id');

      LoadSecNote( Node.ChildNodes, at[1]='h');
     end;
    Node := Node.NextSibling;
  end;
end;

procedure LoadBody(ChNodes: IXMLNodeList; LB : TCheckListBox);
var
 Node: IXMLNode;
begin
 Node := ChNodes.First;
 with cBook do
 while Node <> nil do
  begin

    if lowercase(Node.NodeName) = 'section'
     then LoadSection( Node.ChildNodes, LB)
     else
    if Node.NodeName = 'title'
     then LoadTitle('  Z', Node.ChildNodes, LB)
     else
    if Node.NodeName = 'epigraph'
     then  LoadEpigraph( Node.ChildNodes,  LB);
     {
     else
    if Node.NodeName = 'image'
     then
       LBcon.Items.Add('  i| '+ GetXmlns(Node));

        }
    Node := Node.NextSibling;
  end;
end;


//function assayNode(ChNodes: IXMLNodeList):boolean;
procedure assayNode(ChNodes: IXMLNodeList);
var
 Node: IXMLNode;
begin
 Node := ChNodes.First;
// result := false;
 while Node <> nil do
  begin
  {
      if lowercase(Node.NodeName) = 'fictionbook'
       then
        xlink := Node.HasAttribute('xmlns:xlink')
      else
      }
      if lowercase(Node.NodeName) = 'description'
       then
       begin
        desc:= Node;
       end;

      if Node.NodeName = 'body'
       then
        begin
        if Node.HasAttribute('name')
         then notes:= Node
         else  body:= Node;
        end;
        {
      if Node.NodeName = 'binary'
       then
        GetBinary(Node);
         }

    if Node.HasChildNodes then   //  
          assayNode( Node.ChildNodes);

    Node := Node.NextSibling;
  end;
end;

procedure openXML;
var
 ChNodes: IXMLNodeList;
begin
 fb2Level := 0;   notes := nil;
 with mfb2 do
  begin
 XMLDocument1.Active := true;
 ChNodes := XMLDocument1.ChildNodes;
  end;
  assayNode(ChNodes); //   

//
  if LoadHead(desc.ChildNodes) and w_cat
   then
    begin
     ShowMessage('It''s not w_cat project.');
     exit;
    end;
  LoadBody(body.ChildNodes, CBook.LBcon);
  LoadNotes(notes);
end;

procedure OpenFB2asXML;
begin
 mfb2.XMLDocument1.LoadFromStream(MS,xetUnknown);
 openXML;
end;

end.
