unit s_fb2;

interface
uses Classes, StdCtrls, SysUtils, CheckLst,
     EncdDecd, gv, dm, lib;

  function Build_fb2(a, b, c, d : integer; nf:string):boolean;
  procedure SaveDescr__;

//  procedure SaveBodyFB2(a, b: integer; _LB_ : TCheckListBox);

implementation


var
 SytleStack : TList;
 OutList    : TStringList;


procedure SaveAnnotation(b:boolean; L:TListBox);
var
 i : integer;
begin
if b then OutList.Add('<annotation>')
     else OutList.Add('<p>Annotation</p>');

 with L do
  for i := 0 to Items.Count - 1 do
     OutList.Add('<p>'+Items[i]+'</p>');

if b then OutList.Add('</annotation>');
end;

procedure PrintString(St, E : string);  //  ; b:boolean
begin
 if E <> '' then
   OutList.Add('    <'+St+'>'+E +'</'+St+'>');
end;

procedure PrString(St, E : string);
begin
 if E <> '' then
    OutList.Add('<p>' +St+ ':  '+E +'</p>');
end;

procedure SavePersons(title:string; LB:TListBox);
var
 i : integer;
 Person : TPerson;
begin
 with LB do
 if Count > 0 then
 for i := 0 to Count - 1 do
  begin
   Person := TPerson( Items.Objects[i]);
    OutList.Add('   <'+title+'>');
    with Person do
     begin
      PrintString('first-name',fname);
      PrintString('last-name',lname);
      PrintString('middle-name',mname);
      PrintString('nick',nick);
      PrintString('email',email);
     end;
    OutList.Add('   </'+title+'>');
  end;
end;

procedure PrintPersons(title:string; LB:TListBox);
var
 i : integer;
 Person : TPerson;
 S : string;
begin
 with LB do
 begin
 if Count = 0 then  exit;
 if Count > 1 then title := title + ':'
              else title := title + 's:';
 OutList.Add('<p>'+title+'</p>');
 for i := 0 to Count - 1 do
  begin
   Person := TPerson( Items.Objects[i]);
    S := '';
    with Person do
     begin
      S := fname + ' ' + mname + ' ' + lname;
      S := trim(S);
      OutList.Add('<p>'+S+'</p>');
     end;
  end;
 end;
end;


function GetGaner(S:AnsiString):AnsiString;
var
 i : integer;
begin
 for i := 0 to maxg do
  if gg[i][2] = S then
    begin
     result := gg[i][1];
     exit;
    end;
 result := s;    
end;

procedure SaveSequence(Box   : TListBox; b:boolean);
var
 i : integer;
  Sequ : TSequ;
  S : string;
begin

 for i := 0 to Box.Count - 1 do
   begin
    Sequ := TSequ( Box.Items.Objects[i] );
      if b then
        begin
        S := '<sequence name="' +Sequ.series+'"';
        if  Sequ.number = ''
          then S := S + '/>'
          else S := S + ' number="'+ Sequ.number +'"/>';
        end
      else
         begin
           S := '<p>sequence name="' +Sequ.series+'"';
           if  Sequ.number <> ''
             then S := S + ' number="'+ Sequ.number +'"';
           S := S + '</p>'
         end;
    OutList.Add(S);
   end;

end;

procedure SaveDescription;
const
 max = 5;
 mas : array[1..max] of string =
  (
'<?xml version="1.0" encoding="windows-1251"?>',
'<FictionBook xmlns="http://www.gribuser.ru/xml/fictionbook/2.0"',
'  xmlns:l="http://www.w3.org/1999/xlink">',
'  <description>',
'  <title-info>'
);
var
 i : byte;
 S : string;
begin
 // head
 for i := 1 to max do
  OutList.Add(Mas[i]);
             
 with iBook.Genres_Box do
  if Items.Count > 0 then
  for i := 0 to Items.Count - 1 do
     OutList.Add('<genre>'+GetGaner(Items[i])+'</genre>');

 SavePersons('author',iBook.P_ListBox);

 PrintString('book-title', iBook.Booktitle.text);

 if iBook.MAnnotation.Items.Count > 0
  then SaveAnnotation(true,iBook.MAnnotation);

//if  _date.text <> ''   then
//OutList.Add('<date value="'+_date.text+'-01-01">'+_date.text+'</date>');

OutList.Add('   <lang>'+iBook.P_Lang.Text+'</lang>');

 if iBook.S_Lang.ItemIndex > -1 then
  begin
   S := Lg[iBook.S_Lang.ItemIndex][1];
   if S <> '' then
   OutList.Add('   <src-lang>'+S+'</src-lang>');
 end;

 SavePersons('translator',iBook.T_ListBox);

 SaveSequence(iBook.SequListBox, true);

OutList.Add('  </title-info>');

//       ****  document-info    ****

OutList.Add('  <document-info>');
// <author>
 SavePersons('author', Authors_FB2);

OutList.Add('   <program-used>my_Make_FB2</program-used>');
OutList.Add('   <date value="'+FormatDateTime('yyyy-mm-dd', Now)+'">'+ DateToStr(now) +'</date>');

PrintString('src-url', iBook.EUrl.Text); // ??

PrintString('id', iBook.EId.Text); // ??
if EVersion.Text = ''
 then PrintString('version', '1.0')
 else PrintString('version', EVersion.Text); // ??
//<history
//<publisher
OutList.Add('  </document-info>');

//       ****  publish-info    ****

OutList.Add('  <publish-info>');

  PrintString('book-name', iBook.BookName.Text);
  PrintString('publisher', iBook.EPublisher.Text); //
  PrintString('city', iBook.Ecity.Text); //
  PrintString('year', iBook.Eyear.Text); //
  PrintString('isbn', iBook.Eisbn.Text); //
//  <sequence>
  OutList.Add('  </publish-info>');

  OutList.Add('<custom-info info-type="w_cat">It''s project w_cat</custom-info>');

 OutList.Add(' </description>');
// OutList.Add('<body>');
end;

function SubStyle(m,w : TmyStyle):integer;
begin
 result := integer(m) - integer(w);
end;

procedure SaveDescr__;
begin
 OutList.Clear;
 SaveDescription;
 OutList.Add('</body>');
 OutList.Add('</FictionBook>');
 OutList.SaveToFile(Path+'Descript.txt');
end;

procedure SaveDesc(m:string; Book : TBook);
var
 i : integer;
begin
     OutList.Add('<section>');
     OutList.Add('<title><p>'+m+'</p></title>');
 OutList.Add('<p>genre:</p>');
 with Book do
  begin
    for i := 0 to Genres_Box.Count - 1 do
      begin
       OutList.Add('<p> '+Genres_Box.Items[i]+'</p>');
      end;
    PrintPersons('Author', P_ListBox);
    PrString('Book title', bookTitle.Text);
    PrString('Book name', BookName.Text);
    SaveAnnotation(false, MAnnotation);
    PrintPersons('Translator', T_ListBox);
   if EDate.Text <> '' then 
    OutList.Add('<p>Date: '+EDate.Text+'</p>');
    SaveSequence(SequListBox, false);
  end;
     OutList.Add('</section>');
end;

procedure SaveBodyFB2(a, b: integer; _LB_ : TCheckListBox);
var
 i, j : integer;
 S, ss: string;
 oldStyle,
 LastStyle, CurStyle : TmyStyle; // style
 c : char;

  procedure EndBlock;
  begin
   case oldStyle of //   
         Poem :   OutList.Add('</stanza></poem>');
         Epig   : OutList.Add('</epigraph>');
         Citat  : OutList.Add('</cite>');

         H1..H5 : OutList.Add('</title>');
       end; // case   
  end;

  procedure StyleStucture;
  begin
   if CurStyle <> oldStyle then
      begin
          if SytleStack.Count = 0 then
             begin
              SytleStack.Add(TObject(CurStyle))
             end
             else
             begin
              LastStyle :=  TmyStyle(SytleStack.Last);//(SytleStack.Count-1));
              case SubStyle(CurStyle,LastStyle) of
               0 : OutList.Add('</section>');
               1 : SytleStack.Add(TObject(CurStyle));
               else
               begin
                  OutList.Add('</section>');
                  while CurStyle <> LastStyle do
                  begin
                   SytleStack.Delete(SytleStack.Count-1);
                   OutList.Add('</section>');
                   LastStyle :=  TmyStyle(SytleStack.Last);
                  end;
               end;
               end;// case
             end;
           OutList.Add('<section>');
           OutList.Add('<title>');
      end;
     OutList.Add('<p>'+s+'</p>');
  end;  // StyleStucture;
begin   // SaveBodyFB2
 oldStyle := ZZ;
 OutList.Add('<body>');
 with _LB_ do
 for i := a to b do  //  
  begin
   S := Items[i];
   Ss := GetStyle(S, CurStyle);   //     

if not Checked[i] then
       begin
         if CurStyle in [ H1..H9 ] then
          c := 'h'
          else
          c := 'z';
         ss := //'<a name="a'+IntToStr(m)+ '"></a>'+
           '[<a l:href="#'+c+IntToStr(EndNotes_count)+'" type="note">'+IntToStr(EndNotes_count)+'</a>] '
           + Ss;
         inc(EndNotes_count);
       end;


   s  := '';
   if ss <> '' then
   for j := 1 to length(Ss) do
    begin     //  
     case ss[j] of
      '~' :  begin //    
        S := S + '<a l:href="#n_'+IntToStr(EndNotes_count)+'" type="note">'
                                             +IntToStr(EndNotes_count)+'</a>';
        inc( EndNotes_count ); //   
       end;
      '^' : S := S + '&#769;'; //  
       else S := S + ss[j];
      end; // case
    end;


   if (S = '') and (CurStyle <> Poem)
            then
             begin
              OutList.Add('<empty-line/>');
	      continue;
             end;

   if (CurStyle <> oldStyle) and (CurStyle <> Auth) then
    begin
     EndBlock;

     case CurStyle of //  
       Poem   : OutList.Add('<poem><stanza>');
       Epig   : OutList.Add('<epigraph>');
       Citat  : OutList.Add('<cite>');
     end; // case  
   end;

  //  
  case CurStyle of //     
   Norm,Epig,Citat   : OutList.Add('<p>'+S+'</p>');
   Image  : OutList.Add('<image l:href="#'+S+'"/>');   // <image l:href="#cover.jpg"/>
   H1..H5 : StyleStucture;  // Heading
   Sub    : OutList.Add('<subtitle>'+s+'</subtitle>'); // Subtitle
   Table  : OutList.Add(s); //   
   Poem   : begin
             if S = ''
               then OutList.Add('</stanza><stanza>')
               else OutList.Add('<v>'+S+'</v>');
            end;
   Auth  :  begin
             OutList.Add('<text-author>'+S+'</text-author>');
             if oldStyle in [Poem, Epig, Citat]
		then CurStyle := oldStyle;
            end;
   None  :  continue; //None

  end; // case

  oldStyle := CurStyle;

  end; // for  

  //  ,   ..
  EndBlock;

  if SytleStack.Count > 0 then
   begin //    
    while SytleStack.Count > 0 do
    begin
     SytleStack.Delete(SytleStack.Count-1);
     OutList.Add('</section>');
    end;
   end;

  if NewPr then
    begin
     SaveDesc('English source.', EBook);
     SaveDesc(' .', RBook);
    end;

 OutList.Add('</body>');
end;


procedure SaveEndnotes(c,d:integer);
var
 S : string;
 ch : char;
 i, m : integer;
 CurStyle : TmyStyle;
begin   //   
 with Rus_Box do
  begin

 if Items.Count = 0 then exit;  //<a type="note" l:href="#n_1">[1]</a>

 OutList.Add('<body name="notes"><title><p></p></title>');
 m := 1;

 for i := c to d do
  begin
   S := Items[i];
   S := GetStyle(S, CurStyle);

   if not Checked[i]
    then
     begin
       if CurStyle in [ H1..H9 ] then
        ch := 'h'
        else
        ch := 'z';
      if m > 1 then
      OutList.Add('</section>');
      OutList.Add('<section id="'+ch+IntToStr(m)+'"><title><p>'
                   +IntToStr(m)+'</p></title>');
      inc(m);
     end;
  if m > 1 then
   OutList.Add('<p>'+S+'</p>');
  end;
  OutList.Add('</section>');
 OutList.Add('</body>');

 end;
end;
  {
procedure SaveBinaryFile(S: string);
var
 ex : string;
 i, n  : integer;
 c  : char;
 LSa, LSb : TMemoryStream;
begin
 if FileExists(Image_Path+'\'+S) then
  begin
    LSa := TMemoryStream.Create;
    LSb := TMemoryStream.Create;
   LSa.LoadFromFile(Image_Path+'\'+S);
   LSa.Position := 0;
   EncodeStream(LSa, LSb);

    ex := LowerCase(ExtractFileExt(S));
    if ex = '.jpg'
      then ex := 'image/jpeg'
      else  if ex = '.png'
             then ex := 'image/png';

   OutList.Add('<binary id="'+S
                 +'" content-type="'+ex+'">');


   Ex := '';
   n := LSb.Position;
   LSb.Position := 0;
  // MSb.
   for i := 0 to n-1 do
      begin
       LSb.Read(c,1);
       ex := ex + c;
      end;
   LSa.Free;   LSb.Free;
   OutList.Add(ex);
   OutList.Add('</binary>');
  end;
end;
}
    {
procedure SaveBinary;
var
 i : integer;
begin
 with List_Images do
 for i := 0 to Count - 1 do
    SaveBinaryFile(Items[i]);
end;
        }
function Build_fb2(a,b,c,d: integer; nf:string):boolean;
begin
 result := EBook.LBcon.Items.Count = 0;
 SytleStack.Clear;
 EndNotes_count := 1;
 OutList.Clear;
 SaveDescription;
 SaveBodyFB2(a,b, EBook.LBcon);
 SaveEndnotes(c,d);
//.. SaveBinary;
 OutList.Add('</FictionBook>');

 OutList.SaveToFile(nf);  //++ +
end;


BEGIN
 SytleStack := TList.Create;
 OutList    := TStringList.Create;

END.
